
import Queue

import xmlrpclib

from twisted.internet.defer import Deferred

from twisted.internet.interfaces import IPushProducer

from twisted.web2 import stream

from zope.interface import Interface, Attribute, implements

from twisted.web2 import http, http_headers, xmlrpc
from twisted.python import log, logfile

from xmlreader import Item

#kukitProlog = file("kukitprolog.html", "r").read()

class FeederConfig(Item):
    path = '/@@feeder'
    def _leave(self):
        hw = self._getRoot()
        print "FeederConfig._leave", self._aq('vhostobj').nickname
        feederprolog = getattr(self, 'feederprolog', None)
        self.node= FeederNode(hw, self)
        self._aq('vhostobj').registerWebSite(self.path, self.node)

class FeederPrologConfig(Item):
    def _leave(self):
        self.url = str(self.url)

class FeederApiConfig(Item):
    def _leave(self):
        pass

classMap = dict(
    feeder          = FeederConfig,
    feederprolog    = FeederPrologConfig,
    feederapi       = FeederApiConfig,
)

class EventClient(object):
    def __init__(self, id):
        self.id=id


class EventStream(stream.SimpleStream):
    implements(IPushProducer)
    
    def __init__(self, serv, ctx, id):
        print "EventStream.__init__"
        stream.SimpleStream.__init__(self)
        self.id=id
        self._serv = serv
        self.ctx = ctx
        self.deferredObject=None
        self.dataQueue=Queue.Queue()
        #self.dataQueue.put_nowait(kukitProlog)
    
    def pushData(self, data):
        print "EventStream.pushData"
        #clientObj = self._serv.getClientObj(self.id)
        if isinstance(self.deferredObject, Deferred):
            defer = self.deferredObject
            self.deferredObject=None
            defer.callback(data)
            return
        try:
            self.dataQueue.put_nowait(data)
        except Exception, e:
            print e.__class__.__name__, str(e)
    
    def read(self):
        print "EventStream.read"
        #clientObj = self._serv.getClientObj(self.id)
        try:
            return self.dataQueue.get_nowait()
        except Queue.Empty:
            self.deferredObject = Deferred()
            return self.deferredObject
    
    def stopProducing(self):
        print "stopProducing"
  
    def close(self):
        print "EventStream.close"
        pass


class FeederNode(xmlrpc.XMLRPC):
    def __init__(self, hw, config):
        #print "XmlRpcTopLevel.__init__"
        xmlrpc.XMLRPC.__init__(self)
        self.hw = hw
        self.config = config
        log.msg("FeederNode __init__(%s,%s,%s)" % (self,hw,config))
    
    def sendProlog(self, clientId, stream):
        urlgrabber = self.hw.config.urlgrabber.get()
        defer = urlgrabber.grab(self.config.feederprolog.url)
        defer.addCallback(self.gotPrologStream, clientId, stream)
        #defer.addErrback(
    
    def gotPrologStream(self, prologstream, clientId, output):
        data = prologstream.read()
        if isinstance(data, Deferred):
            data.addCallback(self.gotProlog, clientId, output)
        else:
            self.gotProlog(data, output)
        
    def gotProlog(self, prolog, clientId, output):
        #print "PROLOG", prolog
        output.pushData(prolog)
        clientObj = self.hw.getClientObj(clientId)
        clientObj.eventStream = output
    
    def dispatchData(self, eventId, data):
        print "EventPush.dispatchData"
        for clientId, clientObj in self.hw.clients.items():
            if not hasattr(clientObj, 'eventStream'):
                continue
            print " dispatching data for client  ", clientId
            clientObj.eventStream.pushData(data)
    
    def render(self, request):
        #print "FeederNode.render", request
        clientId = request.args['eventPushId'][0]
        print "GOT a new comet connection under id :", clientId
        if clientId in self.hw.clients:
            raise Exception("SecurityError")
        eventStream=EventStream(self.hw, request, clientId)
        
        self.sendProlog(clientId, eventStream)
        
        hdrs = {'content-type': http_headers.MimeType('text', 'html')}
        return http.Response(code=200,
                             stream=eventStream,
                             headers=hdrs)
    
    def xmlrpc_notify(self, request, eventId, data):
        print "FeederNode.write"#, data
        self.dispatchData(eventId, data)
        return "OK"
    
    def pushUp(self, clientId, data):
        if clientId in self.hw.clients:
            self.hw.clients[clientId].eventStream.pushData(data)
    
    def xmlrpc_pushUp(self, request, clientId, data):
        self.pushUp(clientId, data)
        return "OK"
    
    def xmlrpc_register(self, request, clientId, subscribes):
        return "OK"
        
    def xmlrpc_echo(self, i):
        return i
