# -*- coding: utf-8 -*-


from twisted.internet import reactor, protocol
from twisted.internet import task

from zope.interface import Interface, Attribute, implements

from twisted.application import strports

from twisted.web2 import server, http, resource, channel
from twisted.web2 import static, http_headers, responsecode
from twisted.web2 import stream

#from twisted.web import client

from twisted.python.util import println

import urllib
import configmapper

from xmlreader import parseXml, Item


class WebClient(object):
    def __init__(self, id):
        self.id = id


class HTTPChannel(channel.HTTPFactory.protocol):
    def connectionMade(self):
        channel.HTTPFactory.protocol.connectionMade(self)
        peer = self.transport.getPeer()
        #self.clientId = (peer.host, peer.port)
        #clientObj = self.serv.getClientObj(self.clientId)
        #clientObj.protocol = self
        #print "Yepa", self.clientId

    def timeoutConnection(self):
        print "HTTPChannel.timeoutConnection", getattr(self,'clientId',"NOClientId")
        #self.serv.delClientObj(self.clientId)
        channel.HTTPFactory.protocol.timeoutConnection(self)
    
    def writeConnectionLost(self):
        print "HTTPChannel.writeConnectionLost", getattr(self,'clientId',"NOClientId")
        #self.serv.delClientObj(self.clientId)
        channel.HTTPFactory.protocol.writeConnectionLost(self)
    
    def readConnectionLost(self):
        print "HTTPChannel.readConnectionLost", getattr(self,'clientId',"NOClientId")
        #self.serv.delClientObj(self.clientId)
        channel.HTTPFactory.protocol.readConnectionLost(self)

class HttpWizard(object):
    __parent__ = None

    def __init__(self, application):
        #print "HttpWizard.__init__"
        self.application = application
        self.clients={}
        #initialize registry
        self.registry = dict()
        self.config = Item()
        self.config.__parent__ = self
        parseXml(file("defaults.xml"), root=self.config)
        parseXml(file("httpwizard_conf.xml"), root=self.config)

    def serveSite(self, site, address, port):    
        #set up the HTTP service
        chan = channel.HTTPFactory(site, serv=self)
        chan.protocol = HTTPChannel
        s = strports.service('tcp:%d:%s' % (int(port), address), chan)
        s.setServiceParent(self.application)
    
    def register(self, type, name, obj):
        print "REGISTER %s(%s)" % (str(name), str(type))
        typeDict = self.registry.setdefault(type, {})
        if name in typeDict:
            print "Already registered the name", name, "for this type(", type, ")!!"
        typeDict[name] = obj
        
    def unregister(self, type, name):
        typeDict = self.registry.get(type, {})
        if not name in typeDict:
            print "No registered", type, "under this name", name
        else:
            del typeDict[name]
        if not len(typeDict):
            del self.registry[type]
        self.registry
    
    def getRegistered(self, type, name):
        return self.registry.get(type, {}).get(name, None)
    
    def getClientObj(self, id):
        if not id in self.clients.keys():
            self.clients[id]=WebClient(id)
        return self.clients[id]

    def delClientObj(self, id):
        if id in self.clients:
            del self.clients[id]


