
"""
UrlGrabber
"""

from twisted.internet.defer import Deferred

from xmlreader import PlacefulSingleton

class UrlGrabberConfig(PlacefulSingleton):
    def _leave(self):
        hw = self._getRoot()
        urlgrab = self.get()
        urlgrab.hw = hw
        

classMap = dict(
    urlgrabber = UrlGrabberConfig,
)

class UrlGrabber(object):
    def __init__(self):
        pass
    
    def httpResp(self, resp, myDefer):
        #print "URLGRABBER GOT A RESPONSE !"
        myDefer.callback(resp.stream)
    
    def scheme_http(self, url):
        pass
    
    def scheme_backend(self, url):
        myDefer = Deferred()
        
        backendname = url.split('/')[2]
        backend = self.hw.getRegistered("IBackEnd", backendname)
        backDefer = backend.submitRequest("GET",
                                          "/"+url.split('/',3)[3],
                                          None,
                                          None)
        backDefer.addCallback(self.httpResp, myDefer)
        backDefer.addErrback(lambda error: myDefer.errback(error))
        return myDefer
    
    def scheme_file(self, url):
        pass
    
    def grab(self, url):
        scheme = url.split(':', 1)[0]
        if hasattr(self, 'scheme_'+scheme):
            return getattr(self, 'scheme_'+scheme)(url)
        return None
